Index: pjproject/trunk/third_party/build/srtp/libsrtp.vcxproj
===================================================================
--- pjproject/trunk/third_party/build/srtp/libsrtp.vcxproj	(revision 5265)
+++ pjproject/trunk/third_party/build/srtp/libsrtp.vcxproj	(revision 5266)
@@ -188,5 +188,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -201,5 +201,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
@@ -212,5 +212,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -225,5 +225,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -235,5 +235,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -248,5 +248,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
@@ -259,5 +259,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -272,5 +272,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -282,5 +282,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -295,5 +295,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
@@ -306,5 +306,5 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
       <PrecompiledHeaderOutputFile />
     </ClCompile>
@@ -319,13 +319,12 @@
     <ClCompile>
       <AdditionalIncludeDirectories>.;../../srtp/include;../../srtp/crypto/include;../../../pjlib/include;%(AdditionalIncludeDirectories)</AdditionalIncludeDirectories>
-      <PreprocessorDefinitions>_LIB;%(PreprocessorDefinitions)</PreprocessorDefinitions>
-      <PrecompiledHeaderOutputFile />
-    </ClCompile>
-    <Lib>
-      <OutputFile>..\..\lib\$(ProjectName)-$(TargetCPU)-$(Platform)-vc$(VSVer)-$(Configuration).lib</OutputFile>
-    </Lib>
-  </ItemDefinitionGroup>
-  <ItemGroup>
-    <ClCompile Include="..\..\srtp\crypto\ae_xfm\xfm.c" />
+      <PreprocessorDefinitions>_LIB;HAVE_CONFIG_H;%(PreprocessorDefinitions)</PreprocessorDefinitions>
+      <PrecompiledHeaderOutputFile />
+    </ClCompile>
+    <Lib>
+      <OutputFile>..\..\lib\$(ProjectName)-$(TargetCPU)-$(Platform)-vc$(VSVer)-$(Configuration).lib</OutputFile>
+    </Lib>
+  </ItemDefinitionGroup>
+  <ItemGroup>    
     <ClCompile Include="..\..\srtp\crypto\cipher\aes.c" />
     <ClCompile Include="..\..\srtp\crypto\cipher\aes_cbc.c" />
@@ -350,6 +349,7 @@
     <ClCompile Include="..\..\srtp\pjlib\srtp_err.c" />
     <ClCompile Include="..\..\srtp\srtp\srtp.c" />
+    <ClCompile Include="..\..\srtp\srtp\ekt.c" />
   </ItemGroup>
-  <ItemGroup>
+  <ItemGroup>    
     <ClInclude Include="..\..\srtp\crypto\include\aes.h" />
     <ClInclude Include="..\..\srtp\crypto\include\aes_cbc.h" />
@@ -378,5 +378,5 @@
     <ClInclude Include="..\..\srtp\crypto\include\sha1.h" />
     <ClInclude Include="..\..\srtp\crypto\include\stat.h" />
-    <ClInclude Include="..\..\srtp\crypto\include\xfm.h" />
+    <ClInclude Include="..\..\srtp\include\ekt.h" />
     <ClInclude Include="..\..\srtp\include\rtp.h" />
     <ClInclude Include="..\..\srtp\include\srtp.h" />
Index: pjproject/trunk/third_party/build/srtp/libsrtp.vcxproj.filters
===================================================================
--- pjproject/trunk/third_party/build/srtp/libsrtp.vcxproj.filters	(revision 5265)
+++ pjproject/trunk/third_party/build/srtp/libsrtp.vcxproj.filters	(revision 5266)
@@ -13,7 +13,4 @@
       <UniqueIdentifier>{f75b0fc0-2c2f-43cd-b6c9-116b32197c2b}</UniqueIdentifier>
     </Filter>
-    <Filter Include="crypto\ae_xfm">
-      <UniqueIdentifier>{54f5bab4-bfa9-4c72-b859-693816b56e7f}</UniqueIdentifier>
-    </Filter>
     <Filter Include="crypto\cipher">
       <UniqueIdentifier>{32730aa3-8eba-44b6-9040-cc5f7d7e9656}</UniqueIdentifier>
@@ -45,7 +42,4 @@
       <Filter>Source Files</Filter>
     </ClCompile>
-    <ClCompile Include="..\..\srtp\crypto\ae_xfm\xfm.c">
-      <Filter>crypto\ae_xfm</Filter>
-    </ClCompile>
     <ClCompile Include="..\..\srtp\crypto\cipher\aes.c">
       <Filter>crypto\cipher</Filter>
@@ -107,4 +101,10 @@
     <ClCompile Include="..\..\srtp\crypto\rng\rand_source.c">
       <Filter>crypto\rng</Filter>
+    </ClCompile>
+    <ClCompile Include="..\..\srtp\srtp\ekt.c">
+      <Filter>Source Files</Filter>
+    </ClCompile>
+    <ClCompile Include="..\..\srtp\include\ekt.h">
+      <Filter>Header Files</Filter>
     </ClCompile>
   </ItemGroup>
@@ -200,7 +200,4 @@
       <Filter>crypto\include</Filter>
     </ClInclude>
-    <ClInclude Include="..\..\srtp\crypto\include\xfm.h">
-      <Filter>crypto\include</Filter>
-    </ClInclude>
   </ItemGroup>
 </Project>